
cat("\n")
cat("AFLPScore Version 1.4","\n")
cat("By Raj Whitlock","\n","\n")

cat("Enter input file name?","\n")
answer6<-readLines(n=1)
gen<-read.delim(paste(answer6),header=TRUE)
nloci0<-dim(gen)[2]-1

cat("Would you like to normalise the data to a specified value? (y/n)","\n")
answer<-readLines(n=1)

if(answer=="y"){
cat("Please enter value in relative fluorescence units to which to normalise the data","\n")
medianintense<-as.numeric(readLines(n=1))
}
if(answer=="n")cat("Your data will be normalised to the median  AFLP fingerprint intensity","\n","\n")
if(answer!="y"&answer!="n")cat("Answer not recognised, your data will be normalised to the median AFLP fingerprint intensity","\n","\n")

cat("Would you like to restrict AFLP scoring to a subset of loci? (y/n)","\n")
answer2<-readLines(n=1)
if(answer2!="y") {
cat("All AFLP loci will be analysed","\n")
rejected1<-numeric(0)
}
if (answer2=="y"){
	cat("Enter file name for loci to be retained for scoring","\n")
	restrict<-read.delim(readLines(n=1),header=FALSE)
	cat("Only a subset of AFLP loci will be analysed","\n")

	geny<-gen
	restrict<-paste(unlist(restrict))
	genx<-gen[,match(restrict,names(gen))]
	gen<-cbind(Sample_Names=gen[,1],genx)

	geny<-geny[,-(match(restrict,names(geny)))]
	rejected1 <- names(geny)
	rejected1 <- rejected1[-1]
	nlocix<-dim(gen)[2]-1

}


gen[is.na(gen)] <- 0

if(answer2 != "y"){
	empty_rows<-as.vector(gen[rowSums(gen[,2:(nloci0+1)])==0,1])
	emptyindex<-as.numeric(rownames(gen[rowSums(gen[,2:(nloci0+1)])==0,]))
}

if(answer2 == "y"){
	empty_rows<-as.vector(gen[rowSums(gen[,2:(nlocix+1)])==0,1])
	emptyindex<-as.numeric(rownames(gen[rowSums(gen[,2:(nlocix+1)])==0,]))
}



if((length(emptyindex)>0)==T){gen<-gen[-emptyindex,]}

s_names<-as.data.frame(gen[,1])
gen<-as.data.frame(gen)
nloci<-dim(gen)[2]-1
nsamples<-dim(gen)[1]
rowss<-as.vector(rowSums(gen[,2:(nloci+1)],na.rm=TRUE))
if(answer!="y")medianintense<-median(rowss)
intenseweight<-medianintense/rowss
gen2<-gen[,2:(nloci+1)]*intenseweight
locusintense<-apply(gen[,2:(nloci+1)],2,FUN=function(x)((sum(x[x>0]))/(length(x[x>0]))))
locusintense2<-apply(gen2,2,FUN=function(x)((sum(x[x>0]))/(length(x[x>0]))))
locusintense[is.na(locusintense)] <- 0
locusintense2[is.na(locusintense2)] <- 0
locusintense3<-locusintense2
meanlocusintense<-mean(locusintense[locusintense>0])
meanlocusintense2<-mean(locusintense2[locusintense2>0])

cat(paste("Initial number of loci = ",nloci0),"\n")

if(answer2=="y"){
	cat(paste("Number of loci to be analysed = ",nlocix),"\n")
}

cat(paste("Number of samples = ",nsamples),"\n","\n")
if (answer2=="y")cat(paste("Median fingerprint intensity across non-excluded loci= ","\n",round(medianintense,2),
"Relative frequency units (RFU)","\n","\n"))
if (answer2!="y")cat(paste("Median fingerprint intensity across all loci = ","\n",round(medianintense,2),
"Relative frequency units (RFU)","\n","\n"))
if (answer2!="y")cat(paste("Grand mean normalised intensity of bands across all loci = ","\n",round(meanlocusintense2,2),
"Relative frequency units (RFU)","\n","\n"))
if (answer2=="y")cat(paste("Grand mean normalised intensity of bands across non-excluded loci = ","\n",round(meanlocusintense2,2),
"Relative frequency units (RFU)","\n","\n"))

##########################################################################################
##########################################################################################

AFLPScore<-function(method=1,filter="F",locsel,gensel){

binthresh<-(locsel)
allelethresh<-as.integer(gensel)

if (filter=="T"&method==1){
locusintense2<-apply(gen2,2,FUN=function(x)((sum(x[x>allelethresh]))/(length(x[x>allelethresh]))))
locusintense2[is.na(locusintense2)] <- 0
}

locusintense2[locusintense2<binthresh]<-0; locusintense2[locusintense2>=binthresh]<-1
rem_loci<-locusintense2[locusintense2==0]; ret_loci<-locusintense2[locusintense2==1]
gen3<-gen2[,names(ret_loci)]
if (method==1){
gen3[gen3<allelethresh]<-0
gen3[gen3>=allelethresh]<-1}

if (filter=="F"&method==2){
locusintense3<-locusintense3[locusintense3>=binthresh]
relthresh<-locusintense3*(allelethresh/100)
relthreshmat<-matrix(data=rep(relthresh,nsamples),nsamples,length(ret_loci),byrow=T)
gen3<-gen3-relthreshmat
gen3[gen3>=0]<-1
gen3[gen3<0]<-0}

if (filter=="T"&method==2){
relthresh<-locusintense3*(allelethresh/100)
locusintense4<-matrix(NA,1,nloci)
for (i in 1:nloci){
locusintense4[i]<-mean((gen2[,i])[gen2[,i]>relthresh[i]])}
locusintense4[is.na(locusintense4)] <- 0
locusintense4<-as.data.frame(locusintense4);names(locusintense4)<-names(gen2)
ret_loci<-locusintense4[,locusintense4>=binthresh];rem_loci<-locusintense4[,locusintense4<binthresh]
relthreshmat<-matrix(data=rep(relthresh,nsamples),nsamples,nloci,byrow=T)
gen3<-gen2-relthreshmat
gen3[gen3>=0]<-1
gen3[gen3<0]<-0
gen3<-gen3[,names(ret_loci)]
}

columnsums<-colSums(gen3)
gen3<-cbind(s_names,gen3)
nloci2<-dim(gen3)[2]-1
nsamples2<-dim(gen3)[1]
names(gen3)[1]<-"id"

cat(paste("Locus-selection threshold is ",round(((binthresh/meanlocusintense2)*100),digits=2),
"% of grand mean normalised peak height across loci"),"\n")
if(method==1)cat(paste("Phenotype-calling threshold is ",round(((allelethresh/meanlocusintense2)*100),digits=2),
"% of grand mean normalised peak height across loci"),"\n","\n")
cat(paste("Final number of retained loci = ",nloci2),"\n")
gen_new<-gen3
}


##########################################################################################
plot.new()
par(mfrow=c(1,1))
hist(locusintense2[locusintense2>0],xlab="Mean peak-height of bands at locus",ylab="Frequency of loci",
main="Frequency distribution of mean peak-heights of bands at each locus")

pause <- function ()

{
cat ("Pause. Press <Enter> to continue...")	
readline()
invisible()
}

pause()

n20<-trunc(nloci/20)
rem20<-nloci-(n20*20)

peakplot<-function(x,ab.line,sel){
pkhts<-(gen2[,x])[gen2[,x]>0]
nbs<-length(pkhts)
if(length((pkhts)>0)>1){
dens<-density(pkhts,from=0)
xmax<-max(dens$x);ylim<-range(dens$y);ymax<-max(dens$y)
hist(pkhts,probability=T,xlim=c(0,xmax),ylim=ylim,xlab=NULL,ylab=NULL,main=names(gen2)[x])
lines(dens)
text((xmax*0.8),(ymax*0.8),nbs,cex=1.3,font=3)
if(ab.line==T)abline(v=thr[sel],col=2,lwd=1.5)
}
if(length((pkhts)>0)==1){
xmax<-pkhts[pkhts>0]
hist(pkhts,probability=F,ylab=NULL,xlim=c(0,1.5*xmax),ylim=c(0,10),main=names(gen2)[x])
text((xmax*0.8),(10*0.8),nbs,cex=1.3,font=3)
if(ab.line==T)abline(v=thr[sel],col=2,lwd=1.5)
}

if(sum(pkhts)==0){
plot(0,0,type="n",xaxt="n",yaxt="n",bty="l",main=names(gen2)[x])
text((0.75),(0.6),0,cex=1.3,font=3)
}}

peakplotseries<-function(ab.line){
	if(n20>0){for (j in 1:n20){
		par(mfrow=c(4,5))
		par(mar=c(2,1,2,1))
		par(oma=c(4.2,4.2,0,0))
		for(i in (1+(20*(j-1))):(20*j)){
			peakplot(i,ab.line,i)}
		title(xlab="Peak height, rfu",outer=T,cex.lab=1.5,font.lab=2)
		title(ylab="Density",outer=T,cex.lab=1.5,font.lab=2)
		pause()
		plot.new()
		}}
	if(rem20>0){
	par(mfrow=c(4,5))
	par(mar=c(2,1,2,1))
	par(oma=c(4.2,4.2,0,0))
	for(i in (1+(20*n20)):(dim(gen2)[2])){peakplot(i,ab.line,i)}
	title(xlab="Peak height, RFU",outer=T,cex.lab=1.5,font.lab=2)
	title(ylab="Density",outer=T,cex.lab=1.5,font.lab=2)}}
	peakplotseries(ab.line=F)

#########################################1
#########################################1

cat("\n","\n","Carry out error-rate analysis? (y/n)","\n")
answererror<-readLines(n=1)
if(answererror=="y"){

AFLPError<-function(method=1,filter="F",repeats,Lth=c(200,400,600,800),
Gth=c(50,100,150,200,300,400),errortype=erm){

Lth2<-rep(Lth,each=length(Gth))
Gth2<-rep(Gth,length(Lth))

thresh<-cbind(Lth2,Gth2)
trials<-dim(thresh)[1]

e_table<-matrix(NA,trials,4)



for(i in 1:trials){
genos<-AFLPScore(method=method,filter=filter,locsel=thresh[i,1],gensel=thresh[i,2])
e_table[i,4]<-(dim(genos)[2]-1)
genos<-genos[1:(repeats*2),]

if (errortype=="bayes"){

library("MasterBayes")

GdP<-GdataPed(genos, marker.type="AFLP")
model1<-MCMCped(GdP=GdP, tP=tunePed(E1=100, E2=10),write_postA=T)
e_table[i,1]<-round(median(model1$E1)*100,4)					## Median used to summarise error rates from their posterior distribution
e_table[i,2]<-round(median(model1$E2)*100,4)
A<-extractA(genos, marker.type="AFLP")
p<-unlist(lapply(A, function(x){x[1]}))}

tt<-apply(genos[,-1],2, function(x){table(x,genos[,1])[1,]})
mm<-colSums(tt==1)		## mismatches - only works when each sample has been phenotyped twice.
subs_rate<-sum(mm)/((dim(genos)[1]/2)*(dim(genos)[2]-1))
e_table[i,3]<-round(subs_rate*100,4)}

e_table<-cbind(thresh,e_table)
e_table<-as.data.frame(e_table)
names(e_table)<-c("Loc_thresh","Gen_thresh","E1_percent","E2_percent","Mismatch_percent","N_loci")
e_table<-e_table
}

################################################################

PlotError<-function(data,errortype,geno_thresh,filter){

Lth<-unique(data[,1])
loci<-unique(data[,6])
labels<-paste(Lth,"rfu;",loci, "loci")
if (geno_thresh=="absolute")xlab<-"Phenotype threshold, rfu"
if (geno_thresh=="relative")xlab<-"Phenotype threshold, %"
if (filter=="T")labels<-paste(data[,1],"rfu;",data[,6], "loci")
columns<-1
if (filter=="T")columns<-length(unique(data[,1]))

library(lattice)

if(errortype=="bayes")ylab<-"E1 error rate, %"
if(errortype=="mismatch")ylab<-"Mismatch error rate, %"
if(errortype=="bayes")sort<-3
if(errortype=="mismatch")sort<-5

n<-length(unique(data[,1]))
pch<-1:n
if (filter=="T")pch<-rep((1:n),each=length(unique(data[,2])))
colz<-1:n
if (filter=="T")colz<-rep((1:n),each=length(unique(data[,2])))

xyplot(data[,sort]~Gen_thresh,groups=Loc_thresh,data=data,
xlab = xlab,type="b",
ylab = ylab,
scales=list(tck = c(0.85,0),cex=0.9),
panel = "panel.superpose",
ylim=c(0,max(ceiling(data[,sort]))),
pch=1:n,
key = list(lines = Rows(trellis.par.get("superpose.line"),colz),
cex.title=1,cex=0.9,
text = list(lab = labels),
columns = columns, title = "Locus threshold",type="b",pch=pch,between=0.65,divide=2.5,between.colums=0.5))
}

#####################################################
#####################################################


cat("Enter input AFLP scoring method:","\n")
cat("1. Absolute threshold for phenotype calling","\n")
cat("2. Relative threshold for phenotype calling","\n")
method<-readLines(n=1)
cat("Would you like to filter the data using the phenotype-calling threshold","\n",
"before applying the locus-selection threshold?","\n")
cat("1. Do not filter data","\n")
cat("2. Filter data","\n")
cat("(Answer 1 or 2)","\n")
filter<-readLines(n=1)
if(filter==1){filter<-"F"}
if(filter==2){filter<-"T"}
cat("How many duplicate fingerprint pairs are at the head of the input file?","\n")
repeats<-as.numeric(readLines(n=1))
cat("Enter list of locus-selection thresholds","\n")
Lth<-(readLines(n=1))
Lth<-as.numeric(strsplit(Lth,",")[[1]])
cat("Enter list of phenotype-selection thresholds","\n")
Gth<-(readLines(n=1))
Gth<-as.numeric(strsplit(Gth,",")[[1]])
cat("Enter error-rate method to be calculated (bayes or mismatch)?","\n")
erm<-readLines(n=1)
cat("Create error rate analysis output file? (y/n)","\n")
output<-readLines(n=1)
if(output=="y"){
cat("Enter file name for error rate analysis output file?","\n")
outfile<-readLines(n=1)
}

e.t1 <- AFLPError (method = method, filter = filter, repeats = repeats, Lth = Lth, Gth = Gth)
if (method==1){geno_thresh<-"absolute"}
if (method==2){geno_thresh<-"relative"}
cat("\n","\n")
par(mfrow=c(1,1))
plot.new()
graph<-PlotError (e.t1, errortype = erm, geno_thresh = geno_thresh,filter = filter)
print(graph)
pause()
if(output=="y"){
write.table(e.t1, file=outfile, sep="\t", col.names=TRUE, row.names=FALSE, quote=FALSE)
}
}
#########################################2
#########################################2
cat("\n","\n","Would you like to continue and create a phenotypes table from your data? (y/n)","\n")
ansgeno<-readLines(n=1)
if(ansgeno=="y"){

cat("\n","\n","Please choose an AFLP scoring method:","\n")
cat("1. Absolute threshold for phenotype calling","\n")
cat("2. Relative threshold for phenotype calling","\n")
cat("(Answer 1 or 2)","\n")
answer4<-readLines(n=1)

cat("Would you like to filter the data using the phenotype-calling threshold","\n",
"before applying the locus-selection threshold?","\n")
cat("1. Do not filter data","\n")
cat("2. Filter data","\n")
cat("(Answer 1 or 2)","\n")
answer5<-readLines(n=1)


cat("\n")

cat("Enter locus-selection threshold value, RFU?","\n")
binthresh<-as.integer(readLines(n=1))

if (answer4==1)cat("Enter phenotype-calling threshold value, RFU?","\n")
if (answer4==2)cat("Enter phenotype-calling threshold value, %?","\n")
allelethresh<-as.integer(readLines(n=1))

if (answer5==2&answer4==1){
locusintense2<-apply(gen2,2,FUN=function(x)((sum(x[x>allelethresh]))/(length(x[x>allelethresh]))))
locusintense2[is.na(locusintense2)] <- 0
}

locusintense2[locusintense2<binthresh]<-0; locusintense2[locusintense2>=binthresh]<-1
rem_loci<-locusintense2[locusintense2==0]; ret_loci<-locusintense2[locusintense2==1]
gen3<-gen2[,names(ret_loci)]
if (answer4==1){
gen3[gen3<allelethresh]<-0
gen3[gen3>=allelethresh]<-1}

if (answer5==1&answer4==2){
locusintense3<-locusintense3[locusintense3>=binthresh]
relthresh<-locusintense3*(allelethresh/100)
relthreshmat<-matrix(data=rep(relthresh,nsamples),nsamples,length(ret_loci),byrow=T)
gen3<-gen3-relthreshmat
gen3[gen3>=0]<-1
gen3[gen3<0]<-0}

if (answer5==2&answer4==2){
relthresh<-locusintense3*(allelethresh/100)
locusintense4<-matrix(NA,1,nloci)
for (i in 1:nloci){
locusintense4[i]<-mean((gen2[,i])[gen2[,i]>relthresh[i]])}
locusintense4[is.na(locusintense4)] <- 0
locusintense4<-as.data.frame(locusintense4);names(locusintense4)<-names(gen2)
ret_loci<-locusintense4[,locusintense4>=binthresh];rem_loci<-locusintense4[,locusintense4<binthresh]
relthreshmat<-matrix(data=rep(relthresh,nsamples),nsamples,nloci,byrow=T)
gen3<-gen2-relthreshmat
gen3[gen3>=0]<-1
gen3[gen3<0]<-0
gen3<-gen3[,names(ret_loci)]
}

columnsums<-colSums(gen3)
gen3<-cbind(s_names,gen3)
nloci2<-dim(gen3)[2]-1
nsamples2<-dim(gen3)[1]
names(gen3)[1]<-"Sample_Names"
write.table(gen3, file="newgenos.txt", sep="\t", col.names=TRUE, row.names=FALSE, quote=FALSE)

sumzero<-columnsums[columnsums==0]

locusrecord<-c(rejected1,names(rem_loci),names(ret_loci))
ret_rem<-c(rep("Excluded by user",length(rejected1)),rep("Removed by locus threshold",length(rem_loci)),rep("Retained",length(ret_loci)))
locusrecord<-cbind(ret_rem,locusrecord)
write.table(locusrecord, file="Retained_removed_AFLP_loci.txt", sep="\t", col.names=F, row.names=FALSE, quote=FALSE)
gen<-gen3

cat(paste("Initial number of loci = ",nloci0),"\n")

if(answer2!="y"){
	cat(paste("All loci were retained for analysis by the user"),"\n")
}


if(answer2=="y"){
	cat(paste("Number of loci retained for analysis by user = ",nlocix),"\n")
}

cat(paste("Final number of retained loci = ",nloci2),"\n","\n")
cat(paste("Number of loci specified for removal by user = ",length(rejected1)),"\n")
cat(paste("Number of loci removed by scoring threshold = ",(nloci-nloci2)),"\n")
cat(paste("Total number of removed loci = ",(nloci0-nloci2)),"\n","\n")


if(length(sumzero)==0)cat("All retained loci contain at least 1 peak","\n","\n")
if(length(sumzero)>0){
cat("Some retained loci do not contain any peaks:","\n")
cat(names(sumzero),"\n","\n")}## some loci could be listed that had peaks that were scored as zero!!!

if(length(empty_rows)>0){
cat("Some individuals (data rows) contained no peaks:","\n",empty_rows,"\n",
"These individuals (data rows) were deleted","\n","\n")
}


cat(paste("Locus-selection threshold is ",round(((binthresh/meanlocusintense2)*100),digits=2),
"% of grand mean normalised peak height across loci"),"\n")
if(answer4==1)cat(paste("Phenotype-calling threshold is ",round(((allelethresh/meanlocusintense2)*100),digits=2),
"% of grand mean normalised peak height across loci"),"\n","\n")

if (answer5==2&answer4==2){relthresh<-relthresh[names(ret_loci)]}
n20<-trunc(length(ret_loci)/20)
rem20<-length(ret_loci)-(n20*20)
gen2<-gen2[names(ret_loci)]
if(answer4==1){thr<-rep(allelethresh,length(ret_loci))}
if(answer4==2){thr<-as.numeric(relthresh)}
peakplotseries(ab.line=T)

cat("Output phenotypes table has been stored in 'newgenos.txt'","\n")
cat("Record of retained and removed loci has been stored in 'Retained_removed_AFLP_loci.txt'","\n")
log<-paste("log",format(Sys.time(), "%a %b %d %H_%M_%S %Y"),".txt")
cat("Log of user defined settings and analysis run has been stored in ","'",log,"'","\n","\n","\n")

###############################

cat("AFLPScore Version 1.4","\n",file=log,append=T)
cat("By Raj Whitlock","\n","\n",file=log,append=T)
cat("AFLPScore analysis log for the peak heights table '",answer6,"'","\n",file=log,append=T)
cat(date(),"\n","\n",file=log,append=T)
if(answer4==1)cat("Absolute threshold for phenotype calling selected","\n",file=log,append=T)
if(answer4==2)cat("Relative threshold for phenotype calling selected","\n",file=log,append=T)
if(answer5==1)cat("Data were not filtered using the phenotype-calling",
"\n","threshold prior to application of the locus-selection threshold","\n",file=log,append=T)
if(answer5==2)cat("Data were filtered using the phenotype-calling",
"\n", "threshold prior to application of the locus-selection threshold","\n",file=log,append=T)
if(answer=="y")cat("User-specified normalisation factor was ",medianintense," RFU","\n",file=log,append=T)
if(answer2!="y") cat("All AFLP loci were analysed","\n",file=log,append=T)
if (answer2=="y")cat("A user specified subset of AFLP loci was analysed","\n",file=log,append=T)
cat(paste("Initial number of loci = ",nloci0),"\n",file=log,append=T)
if(answer2=="y"){
	cat(paste("Number of loci retained for analysis by the user = ",nlocix,"\n"),file=log,append=T)
}
cat(paste("Number of samples = ",nsamples),"\n","\n",file=log,append=T)
if (answer2=="y")cat(paste("Median fingerprint intensity across non-excluded loci= ","\n",round(medianintense,2),
"Relative frequency units (RFU)","\n","\n"),file=log,append=T)
if (answer2!="y")cat(paste("Median fingerprint intensity across all loci = ","\n",round(medianintense,2),
"Relative frequency units (RFU)","\n","\n"),file=log,append=T)
if (answer2!="y")cat(paste("Grand mean normalised intensity of bands across all loci = ","\n",round(meanlocusintense2,2),
"Relative frequency units (RFU)","\n","\n"),file=log,append=T)
if (answer2=="y")cat(paste("Grand mean normalised intensity of bands across non-excluded loci = ","\n",round(meanlocusintense2,2),
"Relative frequency units (RFU)","\n","\n"),file=log,append=T)
cat("Locus-selection threshold value was set to ",binthresh," RFU","\n",file=log,append=T)
if (answer4==1)cat("Phenotype-calling threshold value was set to ",allelethresh," RFU","\n",file=log,append=T)
if (answer4==2)cat("Phenotype-calling threshold value was set to ",allelethresh," %","\n",file=log,append=T)
cat(paste("Final number of retained loci = ",nloci2),"\n","\n",file=log,append=T)
cat(paste("Number of loci specified for removal by user = ",length(rejected1)),"\n",file=log,append=T)
cat(paste("Number of loci removed by locus-selection threshold = ",(nloci-nloci2)),"\n",file=log,append=T)
cat(paste("Total number of removed loci = ",(nloci0-nloci2)),"\n","\n",file=log,append=T)
if(length(sumzero)==0)cat("All retained loci contain at least 1 peak","\n","\n",file=log,append=T)
if(length(sumzero)>0){cat("Some retained loci do not contain any peaks:","\n",file=log,append=T)
cat(names(sumzero),"\n","\n",file=log,append=T)}## some loci could be listed that had peaks that were scored as zero!!!

if(length(empty_rows)>0){
cat("Some individuals (data rows) contained no peaks:","\n",empty_rows,"\n",
"These individuals (data rows) were deleted","\n","\n",file=log,append=T)
}

cat(paste("Locus-selection threshold is ",round(((binthresh/meanlocusintense2)*100),digits=2),
"% of grand mean normalised peak height across loci"),"\n",file=log,append=T)
if(answer4==1)cat(paste("Phenotype-calling threshold is ",round(((allelethresh/meanlocusintense2)*100),digits=2),
"% of grand mean normalised peak height across loci"),"\n","\n",file=log,append=T)
cat("Output phenotypes table has been stored in 'newgenos.txt'","\n",file=log,append=T)
cat("Record of retained and removed loci has been stored in 'Retained_removed_AFLP_loci.txt'","\n","\n",file=log,append=T)
cat("END LOG",file=log,append=T)

if (answer2=="y")rm(list=c("restrict","genx","geny"))
if (answer4==2&answer5==2)rm(list=c("locusintense4","i"))
if (answer4==2)rm(list=c("relthresh","relthreshmat"))


todelete<-ls()[ls()!="gen"]
todelete<-todelete[todelete!="AFLPError"]
todelete<-todelete[todelete!="AFLPScore"]
todelete<-todelete[todelete!="PlotError"]

rm(list=todelete)
}
